/**
movieclip class extension written by Vu Duong <vu.duong@masterpiece-softworks.de>

:::How to use:::
Include this file to your flash to get access to the additional class methods.
To use all class extensions read the instruction in the flashclass_extension.as file
*/

trace("flashclass extension <movieclip> loaded");

MovieClip.prototype.loop = function() {
	this.stop();
	p_loops = arguments[0];
	
	var int_count = 0;
	this.onEnterFrame = function() {
		if(int_count++ >= p_loops) {
			this.play();
			delete this.onEnterFrame;
		}
	}
}

MovieClip.prototype.preload = function() {
	var _textDisplay = arguments[0];
	var _jumpPoint = arguments[1];
	var _prefix = (arguments[2] != undefined) ? arguments[2] : "";
	var _suffix = (arguments[3] != undefined) ? arguments[3] : "";

	this.stop();
	
	this.onEnterFrame = function() {
		_textDisplay.text = _prefix + Math.round(this.getBytesLoaded() / 1000) + " (" + Math.round(this.getBytesTotal()/1000) + ") kb" + _suffix;
		if(this.getBytesLoaded() == this.getBytesTotal()) {
			if(_jumpPoint == undefined) this.play(); else this.gotoAndStop(_jumpPoint);
			delete this.onEnterFrame;
		}
	}
}

MovieClip.prototype.getFreeDepth = function() {
	p_range = (arguments[0] != undefined) ? arguments[0] : 0;
	do {
		var depth = random(1000) + p_range;
	} while(this.getInstanceAtDepth(depth) != undefined);
	return depth;
}

MovieClip.prototype.fadeIn = function() {
	var _interval = (arguments[0] != undefined) ? arguments[0] : 20;
	this.createEmptyMovieClip("oef_fade", this.getNextHighestDepth());
	this.oef_fade.onEnterFrame = function() {
		if(this._parent._alpha < 100) {
			this._parent._alpha += _interval;
		} else {
			removeMovieClip(this);
		}				
	}
}

MovieClip.prototype.fadeOut = function() {
	var _interval = (arguments[0] != undefined) ? arguments[0] : 20;
	this.createEmptyMovieClip("oef_fade", this.getNextHighestDepth());
	this.oef_fade.onEnterFrame = function() {
		if(this._parent._alpha > 0) {
			this._parent._alpha -= _interval;
		} else {
			removeMovieClip(this);
		}				
	}
}

MovieClip.prototype.getPath = function() {
	var _filename = this._url.split("/")[this._url.split("/").length - 1];
	var _filepath = this._url.split(_filename)[0];
	return _filepath;
}

MovieClip.prototype.getScale = function() {
	var _scaleFac = (this._xscale + this._yscale) / 2;
}

MovieClip.prototype.setScale = function() {
	var _scaleFac = arguments[0];
	this._xscale = this._yscale = _scaleFac;
}

MovieClip.prototype.addProperty("_path", MovieClip.prototype.getPath, null);

MovieClip.prototype.addProperty("_scale", MovieClip.prototype.getScale, MovieClip.prototype.setScale);

_global.loadExternal = function(p_source, p_mc, p_callback) {
	
	var mclListener = new Object();
	mclListener.onLoadInit = function() {
		
		if(p_callback != undefined) {

			p_callback[0][p_callback[1]]();
			
		}
		
	}
	mclListener.onLoadError = function(p_mc, p_error) {
		
		trace("Error " + p_error);
		
	}
	var mcl = new MovieClipLoader();
	mcl.addListener(mclListener);
	mcl.loadClip(p_source, p_mc);
	
}

_global.colorize = function(p_mc, p_color) {
	
	var myColor = new Color(p_mc);
	myColor.setRGB(p_color);
	
}

ASSetPropFlags(MovieClip.prototype, "loop", 1);
ASSetPropFlags(MovieClip.prototype, "preload", 1);
ASSetPropFlags(MovieClip.prototype, "getFreeDepth", 1);
ASSetPropFlags(MovieClip.prototype, "fadeIn", 1);
ASSetPropFlags(MovieClip.prototype, "fadeOut", 1);
ASSetPropFlags(MovieClip.prototype, "_scale", 1);
ASSetPropFlags(MovieClip.prototype, "getPath", 1);
