/**
object class extension written by Vu Duong <vu.duong@masterpiece-softworks.de>

:::How to use:::
Include this file to your flash to get access to the additional class methods.
To use all class extensions read the instruction in the flashclass_extension.as file
*/

trace("flashclass extension <object> loaded");

Object.prototype.doExist = function() {
	return (this[arguments[0]] != undefined);
}

Object.prototype.hasElementWithValue = function() {
	var value = arguments[0];
	var found = false;
	for(item in this) {
		if(this[item] == value) {
			found = true;
		}
	}
	return found;	
}

Object.prototype.toXML = function() {
	
	var myXML = new XML();
	var _str = '<?xml version="1.0" encoding="UTF-8"?>';

	checkObject = function(p_base) {
		
		p_base.sort();
		
		for(var item in p_base) {
			
			if(item != "attribs") {
			
				if(typeof(p_base[item]["attribs"]) == undefined) {
					
					if(isNaN(item)) {
						_str += "<" + item + ">";
					} else {
						_str += "<list>";
					}
					
				} else {
					if(isNaN(item)) {
						_str += "<" + item;
						checkAttributes(p_base[item]["attribs"]);
						_str += ">";
					} else {
						_str += "<list";
						checkAttributes(p_base[item]["attribs"]);
						_str += ">";
					}
					
				}
				
				var hasObj = false;
				for(var obj in p_base[item]) {
					hasObj = true;
					break;
				}
				if(hasObj) {
					checkObject(p_base[item]);
				} else {
					_str += "<![CDATA[" + p_base[item] + "]]>";
				}
			
				if(isNaN(item)) {
					_str += "</" + item + ">";
				} else {
					_str += "</list>";
				}
				
			}
			
		}
		
	}
	
	checkAttributes = function(p_base) {
		
		for(var item in p_base) {
			
			_str += " " + item + "='" + p_base[item] + "'";
			
		}
		
	}

	checkObject(this);
	trace("Object successfully turned into a XML");
	myXML.parseXML(_str);
	return myXML;
	
}

ASSetPropFlags(Object.prototype, "doExist", 1);
ASSetPropFlags(Object.prototype, "hasElementWithValue", 1);
ASSetPropFlags(Object.prototype, "toXML", 1);
